# This example will test the parallel functionality of your computer.
# It uses the CPU cores to add 1 to a vector of numbers.
# This method uses TCP/IP sockets to communicate to the cores, and so the
# computer's firewall may request permission to allow this
# program to do so.

# Load the parallel library.
library(parallel)

# Get the number of cores on this CPU.
cores <- detectCores()

# Display the number of cores.
print(paste("Number of cores =",cores))

# Make a cluster with the number of cores.
cl <- makeCluster(cores)

# Make a function to add 1.
add1 <- function(n){return (n+1)}

# Make a vector of numbers.
vNumbers <- c(5,20,37,88,49)

# Add 1 to the vector of numbers using the cluster of cores.
result <- clusterApply(cl,vNumbers,fun=add1)

# Display the result.
result

# Stop the cluster.
stopCluster(cl)

# Unload the parallel library.
unloadNamespace("parallel")
